﻿/*
Название: MakeCropMarks.jsx
Приложение для использования: Adobe InDesign CS3, CS4, CS5, CS6
Версия: 1.5
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Создание меток реза
Функциональные ограничения: Не работает с выделенными направляющими
Примечание: Создается дополнительный файл MakeCropMarks.ini для хранения настроек
Техническая поддержка: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
===================================================
Name: MakeCropMarks.jsx
Application to use with: Adobe InDesign CS3, CS4, CS5, CS6
Version: 1.5
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Creates crop marks 
Functional limitations: Can not process containing guides selection
Note: Creates additional file MakeCropMarks.ini for setup data
Technical support: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
*/
// описание глобальных переменных
var the_title = "MakeCropMarks";
var the_version = "1.5";
var AD; // активный док-т
var AL; // активный слой
var AP; // активная страница
var AS;// активный разворот
var the_sel; // выделение в акт. док-те
// границы выделенных объектов
var v_sel_left = new Array();//левые границы выделения объектов
var g_sel_left = new Array();//левые границы выделения объектов
var v_sel_right = new Array();//правые границы выделения объектов
var g_sel_right = new Array();//правые границы выделения объектов
var v_sel_top = new Array();//верхние границы выделения объектов
var g_sel_top = new Array();//верхние границы выделения объектов
var v_sel_bottom = new Array();// нижние границы выделения объектов
var g_sel_bottom = new Array();// нижние границы выделения объектов
//
var N_sel = 0; // кол-во объектов в выделении
var N_doc = 0; //  кол-во док-тов в InDesign
var dlg; // основной диалог
var the_geometric_bounds = true;// расчет по геом. разм если истина, если ложь то по виз.
var AD_old_ruler_origin ;// старые настройки для сохранения
// объекты для построения напр.
var OBJECTS_TO_MAKE = "";
var BOUNDS_TO_MAKE = "Visible";
var BOUNDS_INI = 1;
var ALL_MARKS = new Array();
// массив размеров уже сделанных меток
var L_MADE = new Array();
var T_MADE = new Array();
var R_MADE = new Array();
var B_MADE = new Array();
//
var BL = "\n";// первод строки
//
var H_UNITS_TEXT = "", V_UNITS_TEXT = "";
var SEL_LAYER; // выбранный слой
var WHERE ="";
var B_DROP_ACTIVE = false;
var NA_BOUNDS;
var LL = new Array();
var LV = new Array();
var NO_DIR = false;
var RESTORE_SL = false;
var INP_OK = true;
var cb_tl, cb_tc, cb_tr;
var cb_rt, cb_rc, cb_rb;
var cb_bl, cb_bc, cb_br;
var cb_lt, cb_lc, cb_lb;
var b_clear_all, b_set_all;
var w_cont;
var g_m;
var W_CONT_INI;
var g_m_ini;
var LENGTH_VER, LENGTH_HOR;
var LENGTH_VER_INI, LENGTH_HOR_INI;
var OFFSET_VER, OFFSET_HOR;
var OFFSET_VER_INI, OFFSET_HOR_INI;
var BLEED_VER, BLEED_HOR;
var BLEED_VER_INI, BLEED_HOR_INI;
var str_w_ed_text, SW_NUM;
var str_un_drop;
var SW_NUM_INI;
var SW_UN_INI = 2;
var VER_HOR_ARR = new Array();
//
var SCRIPT_FILE = new File();
var INI_FILE = new File();
var INI_EXISTS = true;
var INI_ERR = false;
// файловая система
var WFS = false;
// созданы ли мастера для меток
var MASTER_VER, MASTER_VER_MADE = false;
var MASTER_HOR, MASTER_HOR_MADE = false;
// неправильный ввод
var BAD_VAL = false;
// точность сравнения координат
var PREC = 0.000001;
//
// вызов главной подпрограммы
main();
// окончание выполнения скрипта :)))
//
// блок описания подпрограмм
// основная подпрограмма
function main () 
{
	// вызываем проверку док-та и выделения
	if ( CHECK_SELECTION()) 
	{
		// получаем координаты выделенных объектов
		SELECTION_DIM();
		// если в порядке выделение и док-т:
		// устанавливаем начальные значения параметров для диалога
		INI_READ();
		//создаем диалог
		dlg = new Window('dialog');
		// определяем файловую систему
		if(File.fs == "Windows") WFS = true;
		dlg.text = the_title + " v." +the_version; // заголовок диалога
		dlg.childrenAlignment = 'center';
		// создание панели чекбоксов для выбора вариантов по направлению
		var mp = dlg.add('panel');
		var mp_left = 5;
		var mp_top = 5;
		var mp_right = 430;
		var mp_bottom = 171;
		mp.bounds = [mp_left, mp_top, mp_right, mp_bottom];
		// габариты чекбокса
		var cb_w = 20;
		var cb_h = 15;
		// шаг чекбоксов по горизонтали 
		var  cb_dx = 50;
		// шаг чекбоксов по вертикали 
		var  cb_dy = 50;
		// 
		// подпрограмма создания чекбокса
		function MAKE_CB( x, y, s, where )
		{
			var cb = where.add('checkbox');
			cb.value = s;
			var c_w = WM( 15, cb_w );
			cb.bounds = [x, y, x+c_w, y+cb_h];
			return cb;
		};// end MAKE_CB
		//
		// подпрограмма создания горизонтальной группы чекбоксов
		function HOR_CB_GROUP( x, y, where )
		{
			var cb_arr = new Array();
			var x_cb = x;
			var s = false;
			for( var i = 0; i < 3; i++ )
			{
				if( i == 0 ) var dx = WM( -3, 0 );
				if( i == 1 ) var dx = WM( -6, -5);
				if( i == 2 ) var dx = WM( -10, -9);
				cb_arr[i] = MAKE_CB( x_cb+dx, y, s, where );
				x_cb = x_cb + cb_dx;
			};// for
			return cb_arr;
		};// end HOR_CB_GROUP
		//
		// подпрограмма создания вертикальной группы чекбоксов
		function VER_CB_GROUP( x, y, where )
		{
			var cb_arr = new Array();
			var y_cb = y;
			var s = false;
			for( var i = 0; i < 3; i++ )
			{
				if( i == 0) var dy = WM( 0, 0 );
				if( i == 1) var dy = WM( -3, -2);
				if( i == 2) var dy = WM(-5, -5);
				cb_arr[i] = MAKE_CB( x,  y_cb+dy, s, where );
				y_cb = y_cb + cb_dy;
			};// for
			return cb_arr;
		};// end VER_CB_GROUP
		//
		// подпрограмма создания кнопки
		function MAKE_BUTTON(x, y, w, where, txt)
		{
			var b = where.add('button');
			var btn_h = 20;
			b.text = txt;
			b.bounds = [x, y, x+w, y+btn_h];
			return b;
		};// end MAKE_BUTTON
		//
		// подпрограмма создания блока выбора направлений
		function MAKE_DIRECTIONS(x, y)
		{
			var cb_arr = new Array();
			var top_bottom_dx = WM( 5, 0 );
			// left
			var left_dx = WM( 4, 0 );
			cb_arr = VER_CB_GROUP( x+2+left_dx, y+cb_h+2, mp );
			cb_lt = cb_arr[0]; cb_lc = cb_arr[1]; cb_lb = cb_arr[2]; 
			// top
			var top_dy = WM( 0, -1 );
			cb_arr = HOR_CB_GROUP( x+cb_w+top_bottom_dx, y+top_dy, mp );
			cb_tl = cb_arr[0]; cb_tc = cb_arr[1]; cb_tr = cb_arr[2]; 
			// right
			var right_dx = WM( 1, 0 );
			cb_arr = VER_CB_GROUP( x + (cb_w+ cb_dx)*2-10+right_dx, y+cb_h+2, mp );
			cb_rt = cb_arr[0]; cb_rc = cb_arr[1]; cb_rb = cb_arr[2]; 
			// bottom
			var bottom_dy = WM( 1, 0 );
			cb_arr = HOR_CB_GROUP( x+cb_w+top_bottom_dx, y + (cb_h +cb_dy)*2 -  bottom_dy , mp );
			cb_bl = cb_arr[0]; cb_bc = cb_arr[1]; cb_br = cb_arr[2]; 
			// создаем плашку
			var rect = mp.add('panel');
			var s = 2;// отступ
			var rect_left = x+cb_w+s;
			var rect_top = y+cb_h+s;
			var rect_right = x + (cb_w-7+ cb_dx)*2-s+5;
			var rect_bottom = y + (cb_h +cb_dy)*2-s;
			rect.bounds = [rect_left, rect_top, rect_right, rect_bottom];
			var s_b = 10;
			var b_left = s_b;
			var b_top =  s_b;
			var b_w = 85;
			var b_w_dx = 33;
			var b_clear_all_y = 10;
			//
			var button_dx = WM( 2, 0 );
			b_left = b_left - button_dx
			// создаем кнопку снять все
			var UNCH_TEXT = WM( "Uncheck all", "Uncheck" );
			b_clear_all = MAKE_BUTTON( b_left, b_clear_all_y, b_w, rect, UNCH_TEXT );
			b_clear_all.onClick = B_CLEAR_ON_CLICK;
			//
			function B_CLEAR_ON_CLICK()
			{
				SET_CB( false );
			};// end B_CLEAR_ON_CLICK
			//
			// создаем кнопку направления по умолчанию
			var b_dir_default_y = b_clear_all_y + b_w_dx;
			b_dir_default = MAKE_BUTTON( b_left, b_dir_default_y, b_w, rect, "Default" );
			b_dir_default.onClick = B_DIR_DEFAULT_ON_CLICK;
			//
			function  B_DIR_DEFAULT_ON_CLICK()
			{
				cb_lt.value=cb_lb.value=
				cb_tl.value=cb_tr.value=
				cb_rt.value=cb_rb.value=
				cb_bl.value=cb_br.value= true;
				cb_lc.value=cb_tc.value=cb_rc.value=cb_bc.value=false;
			};// end B_DIR_DEFAULT_ON_CLICK
			//
			// создаем кнопку выделить все
			var b_set_all_y = b_dir_default_y + b_w_dx;
			b_set_all = MAKE_BUTTON( b_left, b_set_all_y, b_w, rect, "Check all" );
			b_set_all.onClick = B_SET_ON_CLICK;
			//
			function  B_SET_ON_CLICK()
			{
				SET_CB( true );
			};// end B_SET_ON_CLICK
			//
			function SET_CB( act )
			{
				cb_lt.value=cb_lc.value=cb_lb.value=
				cb_tl.value=cb_tc.value=cb_tr.value=
				cb_rt.value=cb_rc.value=cb_rb.value=
				cb_bl.value=cb_bc.value=cb_br.value=
				act;
			};// end SET_CB
			return;
		};// end MAKE_DIRECTIONS
		//
		// собственно создаем блок выбора направлений
		var make_dir_dy = WM( 0, 2 );
		MAKE_DIRECTIONS(mp_left, mp_top+make_dir_dy+2);
		//
		// подпрограмма создания панели ввода параметров
		function MAKE_PANEL(x, y, where, vert_ini, hor_ini, txt)
		{
			var h = 20;
			var w = 50;
			var w_txt = 45;
			var w_un = 30;
			var dx = 3;
			// text
			var txt_left = x, txt_top = y, txt_right = x+w_txt, txt_bottom = y+h; 
			var t = where.add('statictext');
			t.text = txt;
			t.bounds = [txt_left, txt_top, txt_right, txt_bottom];
			//
			// подпрограмма создания окна ввода с единицами
			function ED_TEXT(x_e, y_e, ini_txt, un_txt)
			{
				var et = where.add('edittext');
				var et_left = x_e, et_top = y_e, et_right = et_left+w, et_bottom = y_e+h;
				et.bounds = [et_left, et_top, et_right, et_bottom];
				et.text = ini_txt;
				et.onChanging = et_on_Changing;
				//
				function et_on_Changing()
				{
					digit_on_Changing(et, ini_txt, "0");
				};// end  et_on_Changing
				//
				var un = where.add('statictext');
				var un_left = et_right+dx, un_top = y_e, un_right = un_left+w_un, un_bottom = y_e+h; 
				un.bounds = [un_left, un_top, un_right, un_bottom];
				un.text = un_txt;
				//
				return et;
			};// end ED_TEXT
			//
			var x_et_vert = x+w_txt+dx+10;
			var et_vert = ED_TEXT(x_et_vert, y, vert_ini, V_UNITS_TEXT);
			var et_hor = ED_TEXT(x_et_vert+90, y, hor_ini, H_UNITS_TEXT);
			return [et_vert, et_hor];
		};// end MAKE_PANEL
		//
		// подпрограмма позиционирования текста
		function TEXT_XY(x, y, w, where, txt)
		{
			var t = where.add('statictext');
			t.bounds = [x, y, x+w, y+18];
			t.text = txt;
		};// end TEXT_XY
		//
		// обработка поля ввода в процессе
		function digit_on_Changing(et, def, emp) 
		{
			var s =et.text;
			if( s == "") 
			{
				et.text = emp;
				return;
			};// if
			if( !INP_OK ) 
			{
				et.text = def;
				INP_OK = true;
					return;
			};// if
			var d;
			var BNP = false;
			var N_C = 0;
			var N_P = 0;
			var N_M = 0;
			for( var i=0; i < s.length; i++ ) 
			{
				var si = s[i];
				if( si == "." || si == "," ) N_C = N_C +1;
				if( si == "-" ) N_M = N_M +1;
				if( si == "+" ) N_P = N_P +1;
				if
				( 
					((si != "-" && si != "+" && si != "." && si != "," && NO_DIGIT_SYMBOL(si)) || N_C>1 ) ||
					((N_P + N_M)>1) ||
					( si == "-"  && i !=0 ) ||
					( si == "+"  && i !=0 )
				) 
				{
					BNP = true;
					et.active = true;
					INP_OK = false;
					alert("Bad number input!");
					et.text = def;
					return;
				};// if
			};// for
			return;
		};// end digit_on_Changing
		//
		// обработка поля ввода по завершении
		function digit_on_Change() 
		{
			var txt = et.text;
			if( txt == ""  ||
				 txt == " " ||
				 txt == "-" ||
				 txt == "+"||
				 txt == "." ||
				 txt == "," ||
				 !INP_OK ) et.text = "0";
			if( isNaN( parseFloat (TEXT_TO_DIGIT (et.text)) ) ) 
			{
				et.text = "0";
			};// if
			if( parseFloat (TEXT_TO_DIGIT (et.text)) == 0. ) 
			{
				et.text = "0";
			};// if	
			et.text = parseFloat (TEXT_TO_DIGIT (et.text));
			return;
		};// end digit_on_Change
		//
		// подпрограмма создания панели для опций
		function MAKE_OPTIONS_PANEL(x, y)
		{
			var w_vert = 70;
			var w_hor = 70;
			var y_vert_hor = y-3;
			var dx_vert = 60;
			var x_vert = x+ dx_vert;
			TEXT_XY(x_vert, y_vert_hor, w_vert, mp , "Vertical");
			var dx_hor = 20;
			var x_hor = x_vert + w_vert + dx_hor;
			TEXT_XY(x_hor, y_vert_hor, w_hor, mp, "Horizontal");
			var pan_x = x;
			var pan_y_0 =y + 20;
			var pan_dy = 24;
			// панель для длины
			var pan_y_length = pan_y_0-5;
			VER_HOR_ARR = MAKE_PANEL(pan_x, pan_y_length, mp, LENGTH_VER_INI, LENGTH_HOR_INI, "Length:");
			LENGTH_VER = VER_HOR_ARR[0];
			LENGTH_HOR = VER_HOR_ARR[1];
			// панель для оффсета (отступа)
			var pan_y_offset = pan_y_length + pan_dy;
			VER_HOR_ARR = MAKE_PANEL(pan_x, pan_y_offset, mp, OFFSET_VER_INI, OFFSET_HOR_INI, "Offset:");
			OFFSET_VER = VER_HOR_ARR[0];
			OFFSET_HOR = VER_HOR_ARR[1];
			// панель для вылета
			var pan_y_bleed = pan_y_offset + pan_dy;
			VER_HOR_ARR = MAKE_PANEL(pan_x, pan_y_bleed, mp, BLEED_VER_INI, BLEED_HOR_INI, "Bleed:");
			BLEED_VER = VER_HOR_ARR[0];
			BLEED_HOR = VER_HOR_ARR[1];
			// панель для толщины линии
			var str_w_y = pan_y_bleed + pan_dy+1;
			str_w_txt_w = 90;
			TEXT_XY(pan_x, str_w_y+1, str_w_txt_w, mp , "Stroke weight:");
			str_w_ed_text = mp.add('edittext');
			var str_w_left = x + str_w_txt_w + 3;
			var str_w_ed_tex_w = 55;
			var str_w_right = str_w_left+str_w_ed_tex_w;
			str_w_ed_text.bounds = [str_w_left, str_w_y, str_w_right, str_w_y+22];
			str_w_ed_text.text = SW_NUM_INI;
			str_w_ed_text.onChanging = sw_on_Changing;
			var BAD_SW = false;
			//
			function sw_on_Changing()
			{
				var t = str_w_ed_text.text;
				if( BAD_SW ) { BAD_SW = false; str_w_ed_text.text = SW_NUM_INI; return};
				if( t == "-" )
				{
					str_w_ed_text.text = SW_NUM_INI;
					BAD_SW = true;
					alert("Bad stroke weight!");
					return;
				};// if
				digit_on_Changing(str_w_ed_text, SW_NUM_INI, "0");
				return;
			};// end sw_on_Changing
			//
			// единицы для толщины линии
			str_un_drop = mp.add('dropdownlist');
			var str_un_drop_left = str_w_right +3;
			var str_un_drop_right = str_un_drop_left +70;
			var str_un_drop_bottom = str_w_y+20;
			str_un_drop.bounds = [str_un_drop_left, str_w_y, str_un_drop_right, str_un_drop_bottom];
			str_un_drop.add('item', "mm");
			str_un_drop.add('item', "cm");
			str_un_drop.add('item', "pt");
			str_un_drop.add('item', "in");
			str_un_drop.selection = SW_UN_INI;
			// выбор для группировки
			var g_t = mp.add('statictext');
			g_t.text = "Group after: ";
			var g_m_w = 90;
			var g_m_left = pan_x, g_m_top = str_un_drop_bottom+5, g_m_right = g_m_left+g_m_w, g_m_bottom = g_m_top+20; 
			g_t.bounds = [g_m_left, g_m_top, g_m_right, g_m_bottom];
			g_m = mp.add('dropdownlist');
			g_m.add('item', "Nothing");
			g_m.add('item', "Marks only");
			if( N_sel > 0 ) g_m.add('item', "Marks and selection");
			var g_m_left_d = g_m_right+3;
			var g_m_right_d = g_m_left_d + 128;
			g_m.bounds = [g_m_left_d, g_m_top, g_m_right_d, g_m_top + 20];
			if( g_m_ini == 2 && N_sel == 0 ) g_m_ini = 1;
			g_m.selection = g_m_ini;
			// чекбокс для белого контура
			w_cont = mp.add('checkbox');
			w_cont.text = "White contour around mark";
			var w_cont_left = pan_x, w_cont_top = g_m_bottom+1, w_cont_right = w_cont_left+200, w_cont_bottom = w_cont_top+22; 
			w_cont.bounds = [w_cont_left, w_cont_top, w_cont_right, w_cont_bottom];
			w_cont.value = W_CONT_INI;
			return;
		};// end MAKE_OPTIONS_PANEL
		//
		// осбственно создаем панель опций
		 MAKE_OPTIONS_PANEL(180, 5)
		//
		// подпрограмма создания линиии
		function MAKE_LINE_DIAL() 
		{
			var the_line = dlg.add('panel');
			the_line.bounds = [mp_left, undefined, mp_right, undefined];
			return;
		};// end MAKE_LINE_DIAL
		//
		// создаем группу для выбора объектов и границ
		// как строка внизу
		var OBJ_BOUNDS = dlg.add('group');
		OBJ_BOUNDS.orientation = 'row';
		OBJ_BOUNDS.alignChildren = 'center';
		// 
		// создаем группу выбора объектов слева
		OBJ_GROUP = OBJ_BOUNDS.add('group');
		OBJ_GROUP.orientation = 'row';
		var OBJ_GROUP_TEXT = OBJ_GROUP.add('statictext');
		OBJ_GROUP_TEXT.text = "Object(s):";
		var OBJ_DROP = OBJ_GROUP.add('dropdownlist');
		OBJ_DROP.maximumSize.width = 90;
		OBJ_DROP.onChange = OBJ_DROP_ON_CHANGE;
		//
		function OBJ_DROP_ON_CHANGE() 
		{
			if( OBJ_DROP.selection.text == "Active page" ||
				 OBJ_DROP.selection.text == "Active spread" ) 
			{
				 DROP_ACTIVE_DEACTIVE( B_DROP, false );
			} 
			else 
			{
				DROP_ACTIVE_DEACTIVE( B_DROP, true );
			};// if-else
			return;
		};// end OBJ_DROP_ON_CHANGE
		//
		// подпрограмма деактивации / активации списка
		function DROP_ACTIVE_DEACTIVE( the_drop, act ) 
		{
			var NA;
			if( !act ) 
			{
				if( !the_drop.enabled ) return;
				NA = the_drop.add('item', "N/A");
				NA.selected = true;
				the_drop.enabled = false;
			} 
			else 
			{
				try 
				{
					if( the_drop.enabled ) return;
					the_drop.remove(  the_drop.items[the_drop.items.length-1]  );
					the_drop.items[0].selected = true;
					the_drop.enabled = true;
				} catch ( error ) {};
			};// if
			return;
		};// end DROP_ACTIVE_DEACTIVE
		//
		// если выделены объекты предлагаем выбор границ
		if( N_sel > 0 ) 
		{
			// создаем группу выбора границ
			B_GROUP = OBJ_BOUNDS.add('group');
			B_GROUP.orientation = 'row';
			// 
			B_DROP_ACTIVE = true;
			var B_GROUP_TEXT = B_GROUP.add('statictext');
			B_GROUP_TEXT.text = "Bounds:";
			var B_DROP = B_GROUP.add('dropdownlist');
			B_DROP.maximumSize.width = 90;
			B_DROP.add('item', "Geometric");
			B_DROP.add('item', "Visible");
			B_DROP.selection = BOUNDS_INI;
		};// if
		//
		// создаем группу выбора слоя
		if( AD.layers.length > 1 ) 
		{
			var LAY_GROUP = OBJ_BOUNDS.add('group');
			LAY_GROUP.orientation = 'row';
			var LAY_GROUP_TEXT = LAY_GROUP.add('statictext');
			LAY_GROUP_TEXT.text = "Layer:";
			var LAY_DROP = LAY_GROUP.add('dropdownlist');
			LAY_DROP.maximumSize.width = 90;
			for( var i=0; i < AD.layers.length; i++ )
			{
				var the_lay = LAY_DROP.add('item', AD.layers[i].name);
				if( AD.layers[i] == AL ) the_lay.selected = true;
			};// for
		};// if
		//
		// если есть выделенные объекты
		if( N_sel > 0 ) 
		{
			// только один объект
			if( N_sel == 1 ) OBJ_DROP.add('item', "Selected object");
			// если больше одного объекта
			if( N_sel >= 2 ) 
			{
				OBJ_DROP.add('item', "Entire selection");
				OBJ_DROP.add('item', "Each object in selection");
			};// if
		};// if
		//
		// границы для рабочих областей
		// активная полоса
		OBJ_DROP.add('item', "Active page");
		// если на развороте несколько полос
		if( AS.pages.length > 1) 
		{
			OBJ_DROP.add('item', "Active spread");
		};// if
		OBJ_DROP.selection = 0;
		//
		MAKE_LINE_DIAL();
		// 
		// создание панели кнопок (кнопка ОК, кнопка Cancel)
		dlg.okPanel = dlg.add('group');
		dlg.okPanel.orientation = 'row';
		dlg.okPanel.okBtn = dlg.okPanel.add('button', undefined, 'OK');// кнопка ОК
		dlg.okPanel.cancelBtn =dlg.okPanel.add('button',undefined, 'Cancel');// кнопка Cancel
		//
		// собственно показываем окно диалога
		var DIALOG_BUTTON = dlg.show();
		// если выбрана первая кнопка (ОК) выполняем построение напр.
		if (DIALOG_BUTTON == 1) 
		{
			// объекты
			OBJECTS_TO_MAKE =  OBJ_DROP.selection.text;
			// направления
			cb_lt = cb_lt.value; cb_lc = cb_lc.value; cb_lb = cb_lb.value;
			cb_tl = cb_tl.value; cb_tc =cb_tc.value; cb_tr =cb_tr.value;
			cb_rt = cb_rt.value; cb_rc = cb_rc.value; cb_rb =cb_rb.value;
			cb_bl = cb_bl.value; cb_bc =cb_bc.value; cb_br =cb_br.value;
			// длина
			LENGTH_VER = TEXT_TO_DIGIT( LENGTH_VER.text ); 
			LENGTH_HOR = TEXT_TO_DIGIT( LENGTH_HOR.text );
			// проверяем введенные значения длины
			if( LE_ZERO( LENGTH_VER ) || LE_ZERO( LENGTH_HOR )) 
			{
				the_exit("Bad value input!\n\nCrop mark length can not be < or = zero");
			};// if
			// отступ (офсет)
			OFFSET_VER = TEXT_TO_DIGIT( OFFSET_VER.text ); 
			OFFSET_HOR = TEXT_TO_DIGIT( OFFSET_HOR.text );
			// вылет
			BLEED_VER = TEXT_TO_DIGIT( BLEED_VER.text ); 
			BLEED_HOR = TEXT_TO_DIGIT( BLEED_HOR.text );
			// толщина линии
			SW_UN_INI = str_un_drop.selection.index;
			SW_NUM =  TEXT_TO_POINTS ( str_w_ed_text.text, GET_UNITS_DROP( SW_UN_INI ) );
			// белый контур
			w_cont = w_cont.value;
			// группировать метки и выделение
			g_m_ini = g_m.selection.index;
			g_m = g_m.selection.text;
			// границы
			if( N_sel > 0 ) BOUNDS_TO_MAKE = B_DROP.selection.text
			else BOUNDS_TO_MAKE = "Geometric";
			// слой
			if( AD.layers.length > 1 ) 
			{
				SEL_LAYER = AD.layers[LAY_DROP.selection.index];
			};// if
			// выполнение
			ADDING();
			// записываем начальные значения в файл
			INI_WRITE();
		};// if DIALOG_BUTTON == 1
	};// if CHECK_SELECTION()
	// завершение работы штатное (выход)
	the_exit("");
	return;
};//end main()
//
// продпрограмма выполнения скрипта (в диалоге был ОК)
function ADDING() 
{
	// проверяем есть ли выбранные направления
	var the_dir = cb_lt+cb_lc+cb_lb+
						 cb_tl+cb_tc+cb_tr+
						 cb_rt+cb_rc+cb_rb+
						 cb_bl+cb_bc+cb_br;
	if( the_dir == 0 ) 
	{
		the_exit("No directions were chosen!");
		return;
	};// if
	// открываем выбранный слой
	if( !SEL_LAYER.visible ) SEL_LAYER.visible = true;
	if( SEL_LAYER.locked ) SEL_LAYER.locked = false;
	var AL_WAS_OPEN = false;
	var AL_VISIBLE = AL.visible;
	var AL_LOCKED = AL.locked;
	if( SEL_LAYER.index != AL.index )
	{
		if( !AL_VISIBLE ) { AL.visible = true; AL_WAS_OPEN = true };
		if( AL_LOCKED ) { AL.locked = false; AL_WAS_OPEN = true };
	};// if
	// начинаем выполнение команд из диалога
	// активная полоса
	if( OBJECTS_TO_MAKE == "Active page")
	{
		MARKS( AP.bounds[1], AP.bounds[0], AP.bounds[2], AP.bounds[3]);
	};// if Active page
	// активный разворот
	if( OBJECTS_TO_MAKE == "Active spread")
	{
		MARKS(AS.pages[0].bounds[1], AS.pages[0].bounds[0], AS.pages[0].bounds[2], AS.pages[AS.pages.length-1].bounds[3]);
	};// if Active spread
	// массивы координат в зависимости от границ
	if( OBJECTS_TO_MAKE == "Entire selection" || 
		 OBJECTS_TO_MAKE == "Each object in selection" || 
		 OBJECTS_TO_MAKE == "Selected object")
	{
		var top_arr = new Array();
		var left_arr = new Array();
		var bottom_arr = new Array();
		var right_arr = new Array();
		if( BOUNDS_TO_MAKE == "Geometric" )
		{
			top_arr = g_sel_top; left_arr = g_sel_left;  bottom_arr = g_sel_bottom; right_arr = g_sel_right;
		} 
		else 
		{
			top_arr = v_sel_top; left_arr = v_sel_left;  bottom_arr = v_sel_bottom; right_arr = v_sel_right;
		};// if-else
	};// if
	// выделение целиком или выделен только один объект
	if( OBJECTS_TO_MAKE == "Entire selection" || OBJECTS_TO_MAKE == "Selected object")
	{
		var the_top = MIN_IN_ARRAY( top_arr);
		var the_left = MIN_IN_ARRAY( left_arr );
		var the_bottom = MAX_IN_ARRAY( bottom_arr );
		var the_right = MAX_IN_ARRAY( right_arr );
		MARKS( the_left, the_top, the_bottom, the_right);
	};// if Entire selection Selected object
	// каждый выделенный объект
	if( OBJECTS_TO_MAKE == "Each object in selection" )
	{
		for( var i = 0; i < N_sel; i++ ) MARKS( left_arr[i], top_arr[i], bottom_arr[i], right_arr[i] );
	};// if Each object in selection
	var g_err = false;
	// если задана группировка меток
	if( g_m == "Marks only" || g_m == "Marks and selection")
	{
		// группируем метки
		try
		{
			if( ALL_MARKS.length > 1 ) var G_M = AS.groups.add( ALL_MARKS )
			else var G_M = ALL_MARKS[0];
		} catch ( error ) {  g_err = true };
	};// if "Marks only"
	// если задана группировка меток и выделения
	// группируем метки и выделение
	if( g_m == "Marks and selection")
	{
		// снимаем веделение
		app.selection = null;
		// группируем выделение
		try
		{
			if( N_sel == 1 )  var G_S = the_sel[0]
			else var G_S = AS.groups.add( the_sel );
		} catch ( error ) {  g_err = true };
		// группируем выделение и метки
		try
		{
			var G = AS.groups.add( [G_S, G_M] );
		} catch ( error ) {  g_err = true };	
		// выделяем новую группу
		try
		{
			G.select( SelectionOptions.addTo );
		} catch ( error ) {  g_err = true };
	};// if Marks and selection
	if( g_err )
	try
	{
		app.selection = the_sel;
		alert("Can not group!");
	} catch ( error ) { };
	if( AL_WAS_OPEN )
	{
		AL.visible = AL_VISIBLE;
		AL.locked = AL_LOCKED;
	};// if
	return;
};// end ADDING()
//
// подпрограмма проверки выделения
function CHECK_SELECTION() 
{
	// есть ли открытые документы
	N_doc = app.documents.length;
	if (N_doc < 1 ) 
	{
		alert( "There are no open documents!");
		return false;
	};// if
	AD = app.activeDocument;
	AL = AD.activeLayer;
	SEL_LAYER = AL;
	AP = app.activeWindow.activePage
	AS = app.activeWindow.activeSpread;
	the_sel = AD.selection;
	N_sel = the_sel.length;
	if( GUIDES_IN_SELECTION() ) 
	{
		 alert("There are some selected guides!"+BL+"Can not process that!");
		 return false;
	};// if
	H_UNITS_TEXT = GET_RULER_UNITS_TEXT(AD.viewPreferences.horizontalMeasurementUnits);
	V_UNITS_TEXT = GET_RULER_UNITS_TEXT(AD.viewPreferences.verticalMeasurementUnits);
	return true;
};// end CHECK_SELECTION
//
// подпрограмама поиска направляющих в выделении
function GUIDES_IN_SELECTION() 
{
	if( N_sel > 0 ) 
	{
		if( the_sel[0].constructor.name == "Guide" ) return true;
	};// if
	return false;
};// end GUIDES_IN_SELECTION
//
// подпрограмма вычисления размеров выделения
function SELECTION_DIM() 
{
	// сохраняем старые значения
	SAVE_OLD_DOC_SETTINGS();
	// ставим отсчет как для разворота
	AD.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	// для каждого объекта в выделении
	for(var i=0; i < N_sel; i++) 
	{
		var b_arr = new Array();
		try 
		{
			// получаем общие границы выделенного объекта
			b_arr = SEL_OBJ_BOUNDS ( the_sel[i] );
			// геометрические
			g_sel_left[i] = b_arr[0];
			g_sel_top[i] =  b_arr[1];
			g_sel_right[i] =  b_arr[2];
			g_sel_bottom[i] =  b_arr[3];
			// визуальные
			v_sel_left[i] = b_arr[4];
			v_sel_top[i] =  b_arr[5];
			v_sel_right[i] =  b_arr[6];
			v_sel_bottom[i] =  b_arr[7];
		} 
		catch ( error ) 
		{
			the_exit("Can not process the selection!");
		};// try-catch
	};// for i
	return;
}// end SELECTION_DIM
//
// подпрограмма сохранения старых настроек док-та
function SAVE_OLD_DOC_SETTINGS() 
{
	// сохраняем старые настройки отсчета
	AD_old_ruler_origin = AD.viewPreferences.rulerOrigin;
	return; 
}//end SAVE_OLD_DOC_SETTINGS
// 
// подпрограмма чтения начальных значений из файла
function INI_READ()
{
	// получаем ссылку на файл скрипта
	SCRIPT_FILE = File(app.activeScript);
	// получаем адрес папки со скриптом
	SCRIPT_FOLDER = SCRIPT_FILE.path;
	// получаем ссылку на файл данных
	INI_FILE = File( SCRIPT_FOLDER + "/"+ the_title +".ini" );
	// существует ли он
	INI_EXISTS = INI_FILE.exists;
	// если не существует, получаем начальные значения по умолчанию
	if( !INI_EXISTS ) SET_INI()
	// если существует, получаем начальные значения из этого файла
	else 
	{
		try
		{
			FILE_IO( false );
		} 
		catch ( error ) 
		{
			SET_INI();
		};// try-catch
	};// if-else
	if( INI_ERR ) SET_INI();
	return;
};// end INI_READ
//
// подпрограмма записи начальных значений в файл
function INI_WRITE()
{
	// присваиваем в начальные значения полученные из диалога
	LENGTH_VER_INI = LENGTH_VER+""; LENGTH_HOR_INI = LENGTH_HOR+"";
	OFFSET_VER_INI = OFFSET_VER+""; OFFSET_HOR_INI = OFFSET_HOR+"";
	BLEED_VER_INI = BLEED_VER+""; BLEED_HOR_INI = BLEED_HOR+"";
	SW_NUM_INI = TEXT_TO_DIGIT(str_w_ed_text.text)+""; SW_UN_INI = SW_UN_INI+""; 
	if( w_cont ) W_CONT_INI ="1" else W_CONT_INI = "0";
	g_m_ini = g_m_ini +"";
	if( BOUNDS_TO_MAKE == "Visible" ) BOUNDS_INI = "1" else BOUNDS_INI = "0";
	// существует ли файл (на всякий случай еще раз)
	INI_EXISTS = INI_FILE.exists;
	// если не существует, пытаемся создать
	if( !INI_EXISTS ) 
	{
		try
		{
			// получаем ссылку на файл скрипта
			SCRIPT_FILE = File(app.activeScript);
			// получаем адрес папки со скриптом
			SCRIPT_FOLDER = SCRIPT_FILE.path;
			// получаем ссылку на файл данных
			INI_FILE = File( SCRIPT_FOLDER + "/"+ the_title +".ini" );
		} catch ( error ) {};
	};// if
	try
	{
		FILE_IO( true );
	} catch ( error ) {};
	return;
};// end INI_WRITE
//
// подпрограмма проверки данных при чтении/записи
function BAD_DATA( x )
{ 
	if( isNaN(parseFloat(x)) || x == undefined ) return true;
	return false;
};// end BAD_DATA
//
// подпрограмма чтения/записи в файл данных
// n = true запись
// n = false чтение
function FILE_IO( n )
{
	INI_ERR = false;
	var r = new Array();
	var w = new Array();
	// число параметров ввода/вывода
	var N_PAR = 11;
	try 
	{
		if( n ) 
		{
			w[0] = LENGTH_VER_INI; w[1] = LENGTH_HOR_INI; 
			w[2] = OFFSET_VER_INI; w[3] = OFFSET_HOR_INI;
			w[4] = BLEED_VER_INI;    w[5] = BLEED_HOR_INI;
			w[6] = SW_NUM_INI;       w[7] = SW_UN_INI; 
			w[8] = W_CONT_INI;       w[9] = BOUNDS_INI;
			w[10] = g_m_ini;
		};// if
		// если стина, то открываем на запись
		if( n ) INI_FILE.open("w")
		// если ложь то открываем на чтение
		else INI_FILE.open("r");
		//
		for( var i=0; i < N_PAR; i++ )
		{
			if( n ) 
			{ 
				if ( BAD_DATA( w[i] ) ) INI_ERR = true;
				INI_FILE.writeln( w[i] );
			}
			else 
			{
				r[i] = INI_FILE.readln();
				if ( BAD_DATA( r[i] ) ) INI_ERR = true;
			};// if-else
		};// for
		if( !n ) 
		{
			LENGTH_VER_INI = r[0]; LENGTH_HOR_INI =  r[1]; 
			OFFSET_VER_INI = r[2]; OFFSET_HOR_INI = r[3];
			BLEED_VER_INI = 	 r[4];  BLEED_HOR_INI =   r[5];
			SW_NUM_INI =      r[6]; SW_UN_INI =          r[7]; 
			W_CONT_INI =      r[8]; BOUNDS_INI =         r[9];
			g_m_ini = r[10];
			if( parseInt( W_CONT_INI ) == 1 ) W_CONT_INI = true else W_CONT_INI = false;
		};// if
		// закрываем файл
		INI_FILE.close();
	}
	catch ( error )
	{
		INI_ERR = true;
	};// try-catch
	try{ INI_FILE.close() } catch( error ) {};
	return;
};// end FILE_IO
//
// подпрограмма восстановления старых настроек док-та
function RESTORE_OLD_DOC_SETTINGS() 
{
	AD.viewPreferences.rulerOrigin = AD_old_ruler_origin;
	return; 
}// end RESTORE_OLD_DOC_SETTINGS
//
// функция чтения текстового ввода и перевода в число
function TEXT_TO_DIGIT ( txt ) 
{
	var s = "";
	// если пусто то ноль
	if( txt == "" ) s = "0";
	if( txt == "+" ) s = "0";
	if( txt == "-" ) s = "0";
	var only_space = true;
	for( var i=0; i < txt.length; i++ ) 
	{
		if( txt[i] != " " ) only_space = false;
		if( txt[i] == ",") s = s + "." else s = s + txt[i];
	};// for
	// если только пробелы то ноль
	if( only_space ) s = "0";
	if( s == ".")  s = "0";
	if( s == "-")  s = "0";
	var s1 = "";
	for( var i=0; i < s.length; i++ ) 
	{
		if( s[i] == " " ) continue;
		s1 = s1 + s[i];
	};// for
	var d = parseFloat( s1 );
	// возвращаем значение в пунктах для расчета
	return d;
}// end TEXT_TO_DIGIT
//
// проверка является ли символ цифрой
function NO_DIGIT_SYMBOL( s ) 
{
	try
	{
		if( s!= "0" && s!= "1" && s!= "2" && s!= "3" && s!= "4" && 
			 s!= "5" && s!= "6" && s!= "7" && s!= "8" && s!= "9") return true;
	} catch( error ) {};
	return false;
};// end NO_DIGIT_SYMBOL
//
// подпрограмма определения макс. значения в массиве
function MAX_IN_ARRAY ( the_array) 
{
	var MAX =  the_array[0];
	for ( var i = 0; i < the_array.length; i++ ) 
	{
		if(  the_array[i] > MAX ) MAX =  the_array[i];
	};// for
	return MAX;
}// end  MAX_IN_ARRAY
//
// подпрограмма определения мин. значения в массиве
function MIN_IN_ARRAY ( the_array) 
{
	var MIN =  the_array[0];
	for ( var i = 0; i < the_array.length; i++ ) 
	{
		if(  the_array[i] < MIN ) MIN =  the_array[i];
	};// for
	return MIN;
}// end MIN_IN_ARRAY
//
// подпрограмма получения границ по выделению
function SEL_OBJ_BOUNDS ( the_obj ) 
{
	// left
	var g_L =  the_obj.geometricBounds[1];
	var v_L =  the_obj.visibleBounds[1];
	// top
	var g_T =  the_obj.geometricBounds[0];
	var v_T =  the_obj.visibleBounds[0];
	// right
	var g_R =  the_obj.geometricBounds[3];
	var v_R =  the_obj.visibleBounds[3];
	// bottom
	var g_B =  the_obj.geometricBounds[2];
	var v_B =  the_obj.visibleBounds[2];
	return [g_L, g_T, g_R, g_B,   v_L, v_T, v_R, v_B];
};// end SEL_OBJ_BOUNDS
//
// подпрограмма определения единиц для линеек документа
function GET_RULER_UNITS_TEXT(the_units) 
{
	switch ( the_units ) 
	{
		case (2054188905): return "pt";// points
		case (2054187363): return "pc";// picas
		case (2053729891): return "in";// inches
		case (2053729892): return "ind";// inches decimal
		case (2053991795): return "mm";
		case (2053336435): return "cm";
		case (2053335395): return "ci";// ciceros
		case (1131639917): return "pt";// custom
		case (2051106676): return "ag";// agates
		default: return "??";
	};// switch
	return "??";
};// end GET_RULER_UNITS_TEXT;
//
// подпрограмма создания блока меток справа
function MARK_RIGHT_BLOCK( right, top, bottom ) 
{
	// подпрограмма создания метки справа
	function MARK_RIGHT( r, y )
	{
		var the_left = r + OFFSET_HOR;
		var the_right = the_left + LENGTH_HOR;
		MAKE_MARK_HOR( the_left, the_right, y );
		return;
	};// end MARK_RIGHT
	// право верх
	if( cb_rt ) MARK_RIGHT( right, top+BLEED_VER);
	// право центр
	if( cb_rc ) MARK_RIGHT( right, ( top + (bottom-top)/2.) );
	// право низ
	if( cb_rb ) MARK_RIGHT( right, bottom-BLEED_VER );
	return;
};// end MARK_RIGHT_BLOCK
//
// подпрограмма создания блока меток слева
function MARK_LEFT_BLOCK( left, top, bottom ) 
{
	// подпрограмма создания метки слева
	function MARK_LEFT( l, y )
	{
		var the_right = l - OFFSET_HOR;
		var the_left = the_right - LENGTH_HOR;
		MAKE_MARK_HOR( the_left, the_right, y );
		return;
	};// end MARK_LEFT
	// лево верх
	if( cb_lt ) MARK_LEFT( left, top+BLEED_VER);
	// лево центр
	if( cb_lc ) MARK_LEFT( left, ( top + (bottom-top)/2.) );
	// лево низ
	if( cb_lb ) MARK_LEFT( left, bottom-BLEED_VER );
	return;
};// end MARK_LEFT_BLOCK
//
// подпрограмма создания блока меток сверху
function MARK_TOP_BLOCK( top, left, right) 
{
	// подпрограмма создания метки сверху
	function MARK_TOP( t, x )
	{
		var the_bottom = t - OFFSET_VER;
		var the_top = the_bottom - LENGTH_VER;
		MAKE_MARK_VER( the_top, the_bottom, x );
		return;
	};// end MARK_TOP
	// верх лево 
	if( cb_tl ) MARK_TOP( top, left + BLEED_HOR);
	// лево центр
	if( cb_tc ) MARK_TOP( top, ( left + ( right - left)/2.) );
	// лево низ
	if( cb_tr ) MARK_TOP( top, right - BLEED_HOR );
	return;
};// end MARK_TOP_BLOCK
//
// подпрограмма создания блока меток снизу
function MARK_BOTTOM_BLOCK( bottom, left, right) 
{
	// подпрограмма создания метки сверху
	function MARK_BOTTOM( b, x )
	{
		var the_top = b + OFFSET_VER;
		var the_bottom = the_top + LENGTH_VER;
		MAKE_MARK_VER( the_top, the_bottom, x );
		return;
	};// end MARK_BOTTOM
	// низ лево 
	if( cb_bl ) MARK_BOTTOM( bottom, left + BLEED_HOR);
	// низ центр
	if( cb_bc ) MARK_BOTTOM( bottom, ( left + ( right - left)/2.) );
	// низ низ
	if( cb_br ) MARK_BOTTOM( bottom, right - BLEED_HOR );
	return;
};// end MARK_BOTTOM_BLOCK
//
// подпрограмма создания меток вокруг объекта
function MARKS( left, top, bottom, right)
{
	MARK_LEFT_BLOCK( left, top, bottom);
	MARK_TOP_BLOCK( top, left, right);
	MARK_BOTTOM_BLOCK( bottom, left, right);
	MARK_RIGHT_BLOCK( right, top, bottom );
	return;
};// end MARKS
//
// подпрограмма создания вертикальной линии
function MAKE_MARK_VER(the_top, the_bottom, the_x)
{
	if( ALREADY_MADE(the_x, the_top, the_x, the_bottom ) ) return false;
	var the_obj;
	// если мастер для вертикальной метки не создан
	if( !MASTER_VER_MADE )
	{
		the_obj = MAKE_MARK(the_top, the_x, the_bottom, the_x);
		MASTER_VER_MADE = true;
	}
	else
	// если мастер для вертикальной метки уже создан
	{
		try
		{
			the_obj = MASTER_VER.duplicate();
			var mx = the_obj.geometricBounds[1] + (the_obj.geometricBounds[3] - the_obj.geometricBounds[1])/2.;
			var my = the_obj.geometricBounds[0] + (the_obj.geometricBounds[2] - the_obj.geometricBounds[0])/2.;
			// перемещение по горизонтали
			var dx = the_x - mx;
			// перемещение по вертикали
			var dy = (the_top+(the_bottom-the_top)/2.) - my;
			// собственно перемещаем
			the_obj.move( undefined, [dx, dy] );
		} catch ( error ) {};
	};// if-else
	MASTER_VER = the_obj;
	L_MADE.push( the_x ); T_MADE.push( the_top ); R_MADE.push( the_x ); B_MADE.push( the_bottom );
	// если задана последующая группировка меток и выделения
	if( g_m ) ALL_MARKS.push( the_obj );
	return;
};// end MAKE_MARK_VER
//
//
// подпрограмма создания горизонтальной линии
function MAKE_MARK_HOR(the_left, the_right, the_y)
{
	if( ALREADY_MADE(the_left, the_y, the_right, the_y ) ) return false;
	var the_obj;
	// если мастер для горизонтальной метки не создан
	if( !MASTER_HOR_MADE )
	{
		the_obj = MAKE_MARK(the_y, the_left, the_y, the_right);
		MASTER_HOR_MADE = true;
	}
	else
	// если мастер для горизонтальной метки уже создан
	{
		try
		{
			the_obj = MASTER_HOR.duplicate();
			var mx = the_obj.geometricBounds[1] + (the_obj.geometricBounds[3] - the_obj.geometricBounds[1])/2.;
			var my = the_obj.geometricBounds[0] + (the_obj.geometricBounds[2] - the_obj.geometricBounds[0])/2.;
			// перемещение по горизонтали
			var dx = (the_left+(the_right-the_left)/2.) - mx;
			// перемещение по вертикали
			var dy = the_y - my;
			// собственно перемещаем
			the_obj.move( undefined, [dx, dy] );
		} catch ( error ) {};
	};// if-else
	MASTER_HOR = the_obj;
	L_MADE.push( the_left ); T_MADE.push( the_y ); R_MADE.push( the_right ); B_MADE.push( the_y );
	// если задана последующая группировка меток и выделения
	if( g_m ) ALL_MARKS.push( the_obj );
	return;
};// end MAKE_MARK_HOR
//
// подпрограмма создания метки
function MAKE_MARK(the_top, the_left, the_bottom, the_right)
{
	var the_obj;
	// если задан белый контур сначала делаем расширенную белую линию (1 pt)
	if( w_cont ) 
	{
		var W_L = MAKE_LINE(the_top, the_left, the_bottom, the_right, false, SW_NUM+1.);
	}
	// собственно делаем линию цветом регистр.
	var R_L = MAKE_LINE(the_top, the_left, the_bottom, the_right, true, SW_NUM);
	// создаем группу из белой и регистр. линии
	if( w_cont )
	{
		try
		{
			var G = AS.groups.add([W_L, R_L]);
			the_obj = G;
		} catch ( error ) {};
	}
	else the_obj = R_L;
	return the_obj;
};// end MAKE_MARK
//
// подпрограмма создания линии
function MAKE_LINE(the_top, the_left, the_bottom, the_right, the_color, the_weight)
{
	try
	{
		// создаем новую линию на выбранном слое
		var the_line = app.activeWindow.activeSpread.graphicLines.add(SEL_LAYER);
		// снимаем заливку
		try { the_line.fillColor = AD.swatches.item("None") } catch (error) {};
		// ставим обводку по центру
		try { the_line.strokeAlignment = 1936998723 } catch (error) {};
		// снимаем окончания линий
		try { the_line.rightLineEnd = 1852796517 } catch (error) {};
		try { the_line.leftLineEnd = 1852796517 } catch (error) {};
		try { the_line.endCap = 1650680176 } catch (error) {};
		try { the_line.endJoin = 1835691886 } catch (error) {};
		// присваиваем обводку
		try { the_line.strokeColor = AD.swatches.item("Registration") } catch (error) {};
		//  если цвет истина ставим тинт на 100% (Registration)
		try 
		{
			if( the_color == true )	the_line.strokeTint = -1
			// если цвет ложь ставим тинт на 0% Registration (как бы белый :))
			else the_line.strokeTint = 0 ;
		} catch (error) {};
		// снимаем оверпринт
		try { the_line.overprintStroke = false } catch (error) {};
		// снимаем нонпринтинг
		try { the_line.nonprinting = false } catch (error) {};
		// ставим линию как сплошную
		try { the_line.strokeType = AD.strokeStyles.item("Solid") } catch (error) {};
		// снимаем угловые эффекты
		try { the_line.cornerOption = CornerOptions.NONE } catch (error) {};
		// присваиваем границы
		try { the_line.geometricBounds = [the_top, the_left, the_bottom, the_right] } catch (error) {};
		try { the_line.strokeWeight = the_weight } catch (error) {};
		//
		// подпрограмма снятия эффектов
		function CLEAR_EFFECTS( what )
		{
			with( what )
			{
				// рельеф
				try { bevelAndEmbossSettings.applied = false } catch (error) {}; 
				// режим наложения
				try { blendingSettings.blendMode = BlendMode.NORMAL } catch (error) {}; 
				// нет прозрачности
				try { blendingSettings.opacity = 100 } catch (error) {};
				// размывка направленная
				try { directionalFeatherSettings.applied = false } catch (error) {}; 
				// тень
				try { dropShadowSettings.mode = ShadowMode.NONE } catch (error) {}; 
				// размывка "обычная"
				try { featherSettings.mode = FeatherMode.NONE } catch (error) {}; 
				// размывка градиентная
				try { gradientFeatherSettings.applied = false } catch (error) {}; 
				// внутр. сияние
				try { innerGlowSettings.applied = false } catch (error) {}; 
				// внутр. тень
				try { innerShadowSettings.applied = false } catch (error) {}; 
				// внешнее сияние
				try { outerGlowSettings.applied = false } catch (error) {}; 
				// сатин :)))
				try { satinSettings.applied = false } catch (error) {}; 
			};// with
			return;
		};// end CLEAR_EFFECTS
		// снимаем возможные эффекты обводки
		CLEAR_EFFECTS( the_line.strokeTransparencySettings );
		// снимаем возможные эффекты заливки
		CLEAR_EFFECTS( the_line.fillTransparencySettings );
		// снимаем возможные эффекты объекта
		CLEAR_EFFECTS( the_line.transparencySettings );
		return the_line;
	} catch ( error ) {};
};// end MAKE_LINE
//
// подпрограмма присвоения начальных значений для диалога
function SET_INI()
{
	// длина метки вертикальная
	LENGTH_VER_INI = "5";
	// длина метки горизонтальная
	LENGTH_HOR_INI = "5";
	// отступ вертикальный
	OFFSET_VER_INI = "2";
	// отступ горизонтальный
	OFFSET_HOR_INI = "2";
	// вылет вертикальный
	BLEED_VER_INI = "0";
	// вылет горизонтальный
	BLEED_HOR_INI = "0";
	// толщина линии
	SW_NUM_INI = "0.25";
	// единицы для линии
	SW_UN_INI = 2;
	// белый контур
	 W_CONT_INI = false;
	 // группировка
	 g_m_ini = 0;
	 // границы (ставим визуальные)
	 BOUNDS_INI = 1;
	 return;
};// end SET_INI
//
// функция чтения текстового ввода в активных единицах и перевода в пункты
function TEXT_TO_POINTS ( txt, u ) 
{
	var d = txt.toLowerCase();
	var k = 1.;
	if( u == 'pt' ) k = 1.; 
	if( u == 'in' ) k = 72.; 
	if( u == 'mm' ) k = (72./25.4); 
	if( u == 'cm' ) k = ((72./25.4)*10.);
	d = parseFloat( TEXT_TO_DIGIT(txt) ) * k;
	// если не цифра, обнуляем
	 if( isNaN(d) ) 
	 {
		 d = 0.;
		 exit_if_bad_input = true;
		 return;
	};// if
	// возвращаем значение в пунктах для расчета
	return d;
};// end TEXT_TO_POINTS
//
// подпрограмма получения единиц из меню
function GET_UNITS_DROP( N ) 
{
	if( N == 0 ) return "mm";
	if( N == 1 ) return "cm";
	if( N == 2 ) return "pt";
	if( N == 3 ) return "in";
	return "pt";
};// end GET_UNITS_DROP
//
// подпрограмма окончания скрипта
function the_exit(txt)
{
	try
	{
		RESTORE_OLD_DOC_SETTINGS();
	} catch (error) {};
	if( txt !="") alert(txt);
	exit();
};// end the_exit
//
// подпрограмма определения является ли значение меньше или равно 0
function LE_ZERO( x ) 
{
	try
	{
		if( x <= 0. ) return true;
	} catch( error ) {};
	return false;
};// end LE_ZERO
//
// подпрограмма проверки создана ли уже метка
function ALREADY_MADE( L, T, R, B )
{
	try
	{
		for( var i=0; i < L_MADE.length; i++ )
		{
			if( ( ( Math.abs( L -  L_MADE[i] ) ) < PREC ) && 
			     ( ( Math.abs( T - T_MADE[i] ) ) < PREC ) && 
			     ( ( Math.abs( R - R_MADE[i] ) ) < PREC ) && 
			     ( ( Math.abs( B - B_MADE[i] ) ) < PREC ) ) {return true};
		};// for i
	} catch ( error ) {};
	return false;
};// end ALREADY_MADE
//
// подпрограмма присвоения значения переменной
// в зависимости от файловой системы
function WM( W, M )
{
	// если Windows
	if( WFS ) return W
	// если Macintosh
	else return M;
};// end WM